# generated by datamodel-codegen:
#   filename:  properties_directory/structural/lattice.json
#   version:   0.25.5

from __future__ import annotations

from enum import Enum
from typing import List, Optional

from pydantic import BaseModel, Field


class Name(Enum):
    lattice = "lattice"


class Units(Enum):
    km = "km"
    m = "m"
    pm = "pm"
    nm = "nm"
    angstrom = "angstrom"
    a_u_ = "a.u."
    bohr = "bohr"
    fractional = "fractional"
    crystal = "crystal"
    cartesian = "cartesian"
    alat = "alat"


class LatticeExplicitUnit(BaseModel):
    alat: Optional[float] = 1
    """
    lattice parameter for fractional coordinates
    """
    units: Optional[Units] = None
    a: List[float] = Field(..., max_length=3, min_length=3, title="array of 3 number elements schema")
    b: List[float] = Field(..., max_length=3, min_length=3, title="array of 3 number elements schema")
    c: List[float] = Field(..., max_length=3, min_length=3, title="array of 3 number elements schema")


class LatticeTypeSchema(Enum):
    CUB = "CUB"
    BCC = "BCC"
    FCC = "FCC"
    TET = "TET"
    MCL = "MCL"
    ORC = "ORC"
    ORCC = "ORCC"
    ORCF = "ORCF"
    ORCI = "ORCI"
    HEX = "HEX"
    BCT = "BCT"
    TRI = "TRI"
    MCLC = "MCLC"
    RHL = "RHL"


class Length(Enum):
    angstrom = "angstrom"
    bohr = "bohr"


class Angle(Enum):
    degree = "degree"
    radian = "radian"


class Units36(BaseModel):
    length: Optional[Length] = None
    angle: Optional[Angle] = None


class LatticeSchema(BaseModel):
    name: Optional[Name] = None
    vectors: Optional[LatticeExplicitUnit] = Field(None, title="lattice explicit unit")
    type: LatticeTypeSchema = Field(..., title="lattice type schema")
    units: Optional[Units36] = None
    a: float
    """
    length of the first lattice vector
    """
    b: float
    """
    length of the second lattice vector
    """
    c: float
    """
    length of the third lattice vector
    """
    alpha: float
    """
    angle between first and second lattice vector
    """
    beta: float
    """
    angle between second and third lattice vector
    """
    gamma: float
    """
    angle between first and third lattice vector
    """
